/*
 * OrderListViewSysManager.java
 *
 * Created on 17 de septiembre de 2004, 04:16 PM
 */

package com.fenalco.utilities.lists;

import java.util.Enumeration;
import java.util.Vector;

import com.fenalco.entities.DataAccess;
import com.fenalco.entities.Order;
import com.fenalco.entities.OrderList;
import com.fenalco.entities.Store;

/**
 *
 * @author  Juan Ernesto Peña Kaltekis
 */
public class OrderListViewSupplier implements ListView{
    
    /**
     * El listado (modelo o documento)
     */    
    OrderList orderList;
    /**
     * Como el listado es un hashtable, aqui almaceno los keys
     */    
    private Enumeration keys;
    /**
     * La llave actual que se está trabajando, se usa para tener acceso a los objetos
     * que se deben mostrar de ese elemento de la lista
     */    
    private Object actualKey;
    /**
     * valor actual en el que se está trabajando, es decir, la fila actual de la lista
     */    
    private Order actualValue;
    /**
     * aqui se almacenan los datos que se van a mostrar en las diferentes columnas
     * de la lista
     */    
    private Vector valuesToShow;
    /**
     * contador que indica en que columna voy
     */    
    private int count;
    
    /** Creates a new instance of OrderListViewSysManager */
    public OrderListViewSupplier(OrderList list) {
    	orderList = list;
    	keys = orderList.getOrders().elements();
        
    }
	
	/* (non-Javadoc)
	 * @see com.fenalco.utilities.lists.ListView#move()
	 */
	public boolean move( )
	{
        boolean res = false;
        if( keys.hasMoreElements() )
        {
            actualValue = (Order)keys.nextElement();
            //actualValue = ( Order )orderList.getOrders().get( actualKey );
            
            valuesToShow = new Vector();
            count = 0;
            
            // siempre el primer elemento que mando es el id del objeto (se use o no)
            valuesToShow.addElement( actualValue.getId() + "" );
            valuesToShow.addElement( actualValue.getCompanyName() );
            String shopKeeperName = Store.getCompanyName(actualValue.getStoreId());
            valuesToShow.addElement(shopKeeperName);
            valuesToShow.addElement( actualValue.getStoreName() );
            valuesToShow.addElement( actualValue.getDate() + "" );
            valuesToShow.addElement( DataAccess.getCurrency(actualValue.getValue()));
            valuesToShow.addElement( actualValue.getOrderStatusName() );
            valuesToShow.addElement( actualValue.getSuperOffer() + "" );
            
            /*System.out.println("pedido-> "+actualValue.getId());
            System.out.println("compañia-> "+actualValue.getCompanyName());
            System.out.println("establecimiento-> "+actualValue.getStoreId()+" "+actualValue.getStoreName());*/
            
            
            
            
            res = true;
        }
        return res;
	}

	/* (non-Javadoc)
	 * @see com.fenalco.utilities.lists.ListView#nextElement()
	 */
	public Object nextElement( )
	{
        Object res = null;
        if( valuesToShow != null && valuesToShow.size() > 0)
        {
            if( count < valuesToShow.size() )
            {
                res = valuesToShow.elementAt( count++ );
            }
        }
        return res;
	}
    
}
// “Copyright (C) <2008> Multilateral Investment Fund of the Inter-American Development Bank.
// Este archivo es parte de <ICT4BUS-PVL>
// < ICT4BUS-PVL > es software libre: usted puede redistribuirlo y/o modificarlo bajo los términos de la Licencia Pública General GNU publicada por la Fundación para el Software Libre, ya sea la versión 3 de la Licencia, o (a su elección) cualquier versión posterior.
// < ICT4BUS-PVL > se distribuye con la esperanza de que sea útil, pero SIN GARANTÍA ALGUNA; ni siquiera la garantía implícita MERCANTIL o de APTITUD PARA UN PROPÓSITO DETERMINADO. 
// Consulte los detalles de la Licencia Pública General GNU para obtener una información más detallada. 
// Debería haber recibido una copia de la Licencia Pública General GNU junto a este programa. En caso contrario, consulte http://www.gnu.org/licenses/.”